//---------------------------------------------------------------------------

#include <vcl.h>
#include <ddraw.h>
#pragma hdrstop

#include "AccDraw_.h"
#include "main_.h"
#include "accurate.h"
#include "zx81.h"
#include "zx81config.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

#define DEBUG 0

#define HSYNC_TOLLERANCE 400
#define VSYNC_TOLLERANCE 250
#define HSYNC_MINLEN 12
#define VSYNC_MINLEN 350

//#define HSYNC_TOLLERANCE 400
//#define VSYNC_TOLLERANCE 100
//#define HSYNC_MINLEN 16
//#define VSYNC_MINLEN 350


#if DEBUG==1
int WINDOWRIGHT=413;
int WINDOWBOTTOM=312;
int WINDOWLEFT=0;
int WINDOWTOP=0;
#else
int WINDOWTOP=10;
int WINDOWBOTTOM=290;
int WINDOWLEFT=24;
int WINDOWRIGHT=384;
//int WINDOWLEFT=34;
//int WINDOWRIGHT=354;
//int WINDOWTOP=24;
//int WINDOWBOTTOM=264;
#endif

extern int borrow;
extern int hsync_counter;
extern int rowcounter;

int RasterX=0, RasterY=0;
int TVW, TVH, TVP;
int BPP, ScanLen;
int scanlen[1520];

DWORD Colours[256];

BYTE *dest=NULL, *buffer=NULL;

TDBitCanvas *Frame1=NULL, *Frame2=NULL,
                *CurrentFrame=NULL, *PrevFrame=NULL, *IntFrame=NULL, *Target=NULL;

TRect BorderTop, BorderBottom, BorderLeft, BorderRight;
TRect rcsource, rcdest;

void DoInterlace(void)
{
        int x,y;
        BYTE *New, *Old, *Output;
        DWORD c1,c2;
        BYTE *NewPos, *OldPos, *OutPos;
        DWORD colour=Colours[248];

        New=buffer + WINDOWTOP*TVP;
        Old=(BYTE *)PrevFrame->Lock(FullRect);
        Output=(BYTE *)IntFrame->Lock(FullRect);

        Old += WINDOWTOP*TVP;
        Output += WINDOWTOP*TVP;

        for(y=WINDOWTOP; y<WINDOWBOTTOM; y++)
        {
                NewPos=New+WINDOWLEFT*BPP;
                OldPos=Old+WINDOWLEFT*BPP;
                OutPos=Output+WINDOWLEFT*BPP;

                for(x=WINDOWLEFT; x<WINDOWRIGHT; x++)
                {
                        c1=*(DWORD *)NewPos; c2=*(DWORD *)OldPos;
                        *(DWORD *) OutPos = c1;
                        if (c1 != c2) * (DWORD *)OutPos=colour;

                        NewPos+=BPP;
                        OldPos+=BPP;
                        OutPos+=BPP;
                }

                New += TVP;
                Old += TVP;
                Output += TVP;
        }

        PrevFrame->Unlock(NULL);
        IntFrame->Unlock(NULL);
}
void CompleteFrame(void)
{
        int x=RasterX, y=RasterY;
        dest=buffer + y*TVP;

        while(y<=WINDOWBOTTOM)
        {
                while(x<=(WINDOWRIGHT*BPP))
                {
                        if (BPP==1) dest[x]= 0;
                        else *(DWORD *)(dest+x) = Colours[0];

                        x += BPP;
                }
                x=0;
                y++;
                dest+=TVP;
        }
}

void AccurateUpdateDisplay(bool singlestep)
{
        static int framecounter=0;

        if (++framecounter > zx81.frameskip || singlestep) framecounter=0;
        else return;

        //if (!flip) return;

#if DEBUG==1
        //if (!singlestep && RasterY<WINDOWBOTTOM) CompleteFrame();
        CompleteFrame();
#endif

        if (Form1->Interlaced->Checked) DoInterlace();
        if (singlestep) CurrentFrame->Unlock(NULL);
        else PrevFrame->Unlock(NULL);

        if (Form1->FullScreen)
        {
                Form1->DFlipSurface->Canvas[0]->FillRect(&BorderTop,0);
                Form1->DFlipSurface->Canvas[0]->FillRect(&BorderBottom,0);
                Form1->DFlipSurface->Canvas[0]->FillRect(&BorderRight,0);
                Form1->DFlipSurface->Canvas[0]->FillRect(&BorderLeft,0);
        }

        if (Form1->Interlaced->Checked)
                Form1->DFlipSurface->Canvas[0]->CopyRect(&rcdest,IntFrame,&rcsource);
        else
                if (singlestep)
                        Form1->DFlipSurface->Canvas[0]->CopyRect(&rcdest,CurrentFrame,&rcsource);
                else
                        Form1->DFlipSurface->Canvas[0]->CopyRect(&rcdest,PrevFrame,&rcsource);

        //Form1->DFlipSurface->RepaintTopSurface(NULL);

}

void AccurateUpdateFrame(bool flip)
{
        if (flip)
        {
                if (CurrentFrame==Frame1)
                {
                        CurrentFrame->Unlock(NULL);
                        CurrentFrame=Frame2;
                        PrevFrame=Frame1;
                }
                else
                {
                        CurrentFrame->Unlock(NULL);
                        CurrentFrame=Frame1;
                        PrevFrame=Frame2;
                }
        }

        buffer=(BYTE *)CurrentFrame->Lock(FullRect);

#if DEBUG==1
        int i,j;
        dest=buffer;
        for(i=0;i<TVH;i++)
        {
                for(j=0;j<TVW;j++) dest[j]=1;
                dest += TVP;
        }
#endif
}

#if DEBUG==2
void shiftleft(BYTE *b, int len, int pos)
{
        int i,j;

        for(j=0;j<pos;j++)
        for(i=0; i<(len);i++) b[i] = b[i+1];
}

void shiftright(BYTE *b, int len, int pos)
{
        int i,j;

        for(j=0;j<pos;j++)
        for(i=len; i>pos ;i--) b[i] = b[i-1];
}

void CheckHSync(int FrameLen)
{
        int i,j, offset=0, target=0, temp;
        BYTE *b = buffer + 15*TVP;

        //int average=0;
        //for(i=15;i<(FrameLen-15);i++) average+=scanlen[i];
        //average /= FrameLen-15;

        for(i=15;i<(FrameLen-15);i++)
        {
                if ((scanlen[i]!=scanlen[i-1]) && scanlen[i] != scanlen[i-2] && (scanlen[i]==scanlen[i+1]) && (scanlen[i]==scanlen[i+2]) )
                //if ( temp!=0  ) //&& temp>-10 && temp<10 )
                        b[10]=0;//target=(scanlen[i]-scanlen[i-1]);
                //else target=0;
                //if (offset>0) shiftleft(b, scanlen[i], offset);
                //if (offset<0) shiftright(b, scanlen[i], offset);

                if (offset>target) offset--;
                if (offset<target) offset++;

                b += TVP;

        }
}
#else
#define CheckHSync(x)
#endif

int AccurateDraw()
{
        int i,j;

        dest = buffer + RasterY*TVP;

        for(i=0; i<scanline_len; i++)
        {
                if (BPP==1) dest[RasterX]= scanline[i];
                else *(DWORD *)(dest+RasterX) = Colours[scanline[i]];

                RasterX += BPP;

                if (RasterX > ScanLen)
                {
                        scanlen[RasterY]=RasterX;
                        RasterX=0;
                        RasterY++;
                        dest += TVP;
                }

                if (RasterY>379)
                {
                        CheckHSync(RasterY);
                        AccurateUpdateFrame(true);
                        RasterX=0;
                        RasterY=0;
                        dest=buffer;
                }

        }
        if (sync_len<HSYNC_MINLEN) sync_valid=0;
        if (sync_valid)
        {
                if (RasterX>(HSYNC_TOLLERANCE*BPP))
                {
                        scanlen[RasterY]=RasterX;
                        RasterX=0;
                        RasterY++;
                        dest += TVP;
                }
                if (RasterY>360 || (sync_len>VSYNC_MINLEN && RasterY>VSYNC_TOLLERANCE))
                {
                        CheckHSync(RasterY);
                        AccurateUpdateFrame(true);
                        RasterX=RasterY=0;
                        dest=buffer;
                        //AccurateUpdateDisplay(false);
                }

                sync_len=0;
                sync_valid=-1;
        }

        if (zx81.single_step)
        {
                int i;

                for(i=0;i<8;i++) *(DWORD *)(dest+RasterX+i*BPP) = Colours[15];
                AccurateUpdateDisplay(true);
        }
        return(0);
}

void RecalcWinSize(void)
{
        BorderTop.Top=0;
        BorderTop.Bottom=20;
        BorderTop.Left=0;
        BorderTop.Right=800;

        BorderBottom.Top=580;
        BorderBottom.Bottom=600;
        BorderBottom.Left=0;
        BorderBottom.Right=800;

        BorderLeft.Top=20;
        BorderLeft.Bottom=580;
        BorderLeft.Left=0;
        BorderLeft.Right=40;

        BorderRight.Top=20;
        BorderRight.Bottom=580;
        BorderRight.Left=760;
        BorderRight.Right=800;

        if (zx81.NTSC)
        {
                BorderTop.Bottom=60;
                BorderBottom.Top=540;
                BorderLeft.Top=60;
                BorderLeft.Bottom=540;
                BorderRight.Top=60;
                BorderRight.Bottom=540;
        }

        if (Form1->FullScreen)
        {
                        rcdest.Left=40;
                        rcdest.Right=760;
                        if (zx81.NTSC)
                        {
                                rcdest.Top=60;
                                rcdest.Bottom=540;
                        }
                        else
                        {
                                rcdest.Top=20;
                                rcdest.Bottom=580;
                        }
        }
        else
        {
                rcdest.Top=0;
                rcdest.Left=0;
                rcdest.Right=Form1->DFlipSurface->Width;
                rcdest.Bottom=Form1->DFlipSurface->Height;
        }

        rcsource.Right=WINDOWRIGHT;
        rcsource.Bottom=WINDOWBOTTOM;
        rcsource.Left=WINDOWLEFT;
        rcsource.Top=WINDOWTOP;
}

void RecalcPalette(void)
{
        PALETTEENTRY pal[256], *p;
        //IDirectDraw *dd;
        DDPIXELFORMAT *ddpf;
        int i,r,g,b;

        for(i=0;i<256;i++)
        {
                r=(Form1->DImage1->Palette[i]&0x000000ff);
                g=(Form1->DImage1->Palette[i]&0x0000ff00)>>8;
                b=(Form1->DImage1->Palette[i]&0x00ff0000)>>16;

                pal[i]=MakePaletteEntry(r,g,b,0);
        }

        ddpf = Form1->DFlipSurface->Canvas[0]->PixelFormat;

        DBits::FillInTranslationTable(256, pal,
                                        ddpf->dwRBitMask,
                                        ddpf->dwGBitMask,
                                        ddpf->dwBBitMask, Colours);
}

void AccurateInit(void)
{
        Form1->DImage1->SetDimensions(520,380,Form1->DImage1->ScreenBpp);
        Form1->DImage3->SetDimensions(520,380,Form1->DImage1->ScreenBpp);
        Form1->DImage2->SetDimensions(520,380,Form1->DImage1->ScreenBpp);
        BPP=Form1->DImage1->ScreenBpp/8;
        ScanLen=518*BPP;

#if DEBUG==0
        if (zx81.NTSC) WINDOWBOTTOM=250;
        //else WINDOWBOTTOM=264;
        else WINDOWBOTTOM=290;
#endif

/*#if DEBUG==1
        Form1->BaseWidth=520;
        Form1->BaseHeight=380;
        Form1->ClientWidth=520;
        Form1->ClientHeight=380;
        Form1->DFlipSurface->Width=520;
        Form1->DFlipSurface->Height=380;
#else
*/
        Form1->BaseWidth=WINDOWRIGHT-WINDOWLEFT;
        Form1->BaseHeight=WINDOWBOTTOM-WINDOWTOP;
        Form1->ClientWidth=Form1->BaseWidth;
        Form1->ClientHeight=Form1->BaseHeight;
        Form1->DFlipSurface->Width=Form1->BaseWidth;
        Form1->DFlipSurface->Height=Form1->BaseHeight;

//#endif
        zx81_init();

        //Target=Form1->DFlipSurface->Canvas[0];
        Frame1=Form1->DImage1->Canvas;
        Frame2=Form1->DImage2->Canvas;
        IntFrame=Form1->DImage3->Canvas;
        CurrentFrame = Frame2;
        PrevFrame=Frame1;

        TVH=CurrentFrame->Height;
        TVW=CurrentFrame->Width;
        TVP=CurrentFrame->Pitch;

        Frame1->Unlock(NULL);
        Frame2->Unlock(NULL);

        // buffer=(BYTE *)Form1->DImage1->Canvas->Lock(FullRect);
        buffer=(BYTE *)CurrentFrame->Lock(FullRect);

        BorderTop.Top=0;
        BorderTop.Bottom=20;
        BorderTop.Left=0;
        BorderTop.Right=800;

        BorderBottom.Top=580;
        BorderBottom.Bottom=600;
        BorderBottom.Left=0;
        BorderBottom.Right=800;

        BorderLeft.Top=20;
        BorderLeft.Bottom=580;
        BorderLeft.Left=0;
        BorderLeft.Right=40;

        BorderRight.Top=20;
        BorderRight.Bottom=580;
        BorderRight.Left=760;
        BorderRight.Right=800;

        RecalcPalette();
        RecalcWinSize();
}
