//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Artifacts_.h"
#include "main_.h"
#include "zx81config.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

extern void RecalcPalette(void);

TArtifacts *Artifacts;
//---------------------------------------------------------------------------
__fastcall TArtifacts::TArtifacts(TComponent* Owner)
        : TForm(Owner)
{
        TIniFile *ini;

        ini = new TIniFile(ChangeFileExt(Application->ExeName, ".INI" ));
        LoadSettings(ini);
        delete ini;
}
//---------------------------------------------------------------------------
void __fastcall TArtifacts::CloseBtnClick(TObject *Sender)
{
        Close();
}
//---------------------------------------------------------------------------
void __fastcall TArtifacts::FormClose(TObject *Sender,
      TCloseAction &Action)
{
        Form1->DisplayArt->Checked = false;
}
//---------------------------------------------------------------------------
void __fastcall TArtifacts::TrackBarChange(TObject *Sender)
{
        int level1,level2,r,g,b,colour,i;

        level1 = TrackBar1->Position;
        level2 = TrackBar2->Position;

        for(i=0;i<8;i++)
        {
                colour = Form1->DFlipSurface->Palette[128+i*4];

                b= ((colour&0x00ff0000)>>16);
                g= ((colour&0x0000ff00)>>8);
                r= (colour&0xff);

                b += level1; g += level1; r += level1;
                colour = (((b>255?255:(b<0?0:b))&0xff)<<16)
                                | (((g>255?255:(g<0?0:g))&0xff)<<8)
                                | ((r>255?255:(r<0?0:r))&0xff);
                Form1->DFlipSurface->Palette[128+i*4+1]=(TColor) colour;

                b += level2; g += level2; r += level2;
                colour = (((b>255?255:(b<0?0:b))&0xff)<<16)
                                | (((g>255?255:(g<0?0:g))&0xff)<<8)
                                | ((r>255?255:(r<0?0:r))&0xff);
                Form1->DFlipSurface->Palette[128+i*4+3]=(TColor) colour;

                b -= level1; g -= level1; r -= level1;
                colour = (((b>255?255:(b<0?0:b))&0xff)<<16)
                                | (((g>255?255:(g<0?0:g))&0xff)<<8)
                                | ((r>255?255:(r<0?0:r))&0xff);
                Form1->DFlipSurface->Palette[128+i*4+2]=(TColor) colour;
        }

        for(i=0; i<256;i++)
        {
                Form1->DImage1->Palette[i]=Form1->DFlipSurface->Palette[i];
                Form1->DImage2->Palette[i]=Form1->DFlipSurface->Palette[i];
                Form1->DImage2->Palette[i]=Form1->DFlipSurface->Palette[i];
        }

        RecalcPalette();
}
//---------------------------------------------------------------------------


void __fastcall TArtifacts::ArtEnabledClick(TObject *Sender)
{
        if (ArtEnabled->Checked && Form1->Interlaced->Checked)
                Form1->InterlacedClick(NULL);

        zx81.dirtydisplay= ArtEnabled->Checked;

}
//---------------------------------------------------------------------------
void TArtifacts::SaveSettings(TIniFile *ini)
{
        ini->WriteInteger("ARTIFACTS","Top",Top);
        ini->WriteInteger("ARTIFACTS","Left",Left);
        ini->WriteInteger("ARTIFACTS","Height",Height);
        ini->WriteInteger("ARTIFACTS","Width",Width);
        ini->WriteInteger("ARTIFACTS","Noise",TrackBar1->Position);
        ini->WriteInteger("ARTIFACTS","Ghosting",TrackBar2->Position);
        ini->WriteBool("ARTIFACTS", "ArtEnabled", ArtEnabled->Checked);
}

void TArtifacts::LoadSettings(TIniFile *ini)
{
        int DefaultLevel=230, c,i;

        Top = ini->ReadInteger("ARTIFACTS","Top",Top);
        Left = ini->ReadInteger("ARTIFACTS","Left",Left);
        Height = ini->ReadInteger("ARTIFACTS","Height",Height);
        Width = ini->ReadInteger("ARTIFACTS","Width",Width);
        TrackBar1->Position= ini->ReadInteger("ARTIFACTS","Noise",TrackBar1->Position);
        TrackBar2->Position= ini->ReadInteger("ARTIFACTS","Ghosting",TrackBar2->Position);
        ArtEnabled->Checked= ini->ReadBool("ARTIFACTS", "ArtEnabled", ArtEnabled->Checked);

        if (Form1->DisplayArt->Checked) Show();

        for(i=0;i<8;i++)
        {
                c=0;
                if (i&1) c += DefaultLevel<<16;
                if (i&2) c += DefaultLevel;
                if (i&4) c += DefaultLevel<<8;

                Form1->DFlipSurface->Palette[128+i*4]=(TColor) c;
        }
        TrackBarChange(NULL);
}
