//---------------------------------------------------------------------------

#ifndef Hardware_H
#define Hardware_H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Dialogs.hpp>
#include <IniFiles.hpp>
//---------------------------------------------------------------------------

#define RAM1k   0
#define RAM2k   1
#define RAM4k   2
#define RAM8k   3
#define RAM16k  4
#define RAM32k  5
#define RAM48k  6

class THardware : public TForm
{
__published:	// IDE-managed Components
        TComboBox *RamPack;
        TLabel *Label1;
        TCheckBox *ShadowROM;
        TCheckBox *EnableRAM8k;
        TCheckBox *ProtectROM;
        TButton *Button1;
        TLabel *Label2;
        TComboBox *Model;
        TCheckBox *NTSCMachine;
        TLabel *Label4;
        TComboBox *Hres;
        TLabel *Label5;
        TComboBox *AY8910;
        TLabel *Label6;
        TComboBox *ColourBox;
        TCheckBox *M1Not;
        TListBox *RomFile;
        TLabel *Label3;
        TComboBox *SerialPort;
        TLabel *Label7;
        TButton *SerialConfigBtn;
        TLabel *Label8;
        TComboBox *ChrGenBox;
        void __fastcall Button1Click(TObject *Sender);
        void __fastcall EnableRAM8kClick(TObject *Sender);
        void __fastcall ModelChange(TObject *Sender);
        void __fastcall ShadowROMClick(TObject *Sender);
        void __fastcall HresChange(TObject *Sender);
        void __fastcall ColourBoxChange(TObject *Sender);
        void __fastcall RomFileClick(TObject *Sender);
        void __fastcall FormShow(TObject *Sender);
        void __fastcall SerialPortChange(TObject *Sender);
        void __fastcall SerialConfigBtnClick(TObject *Sender);
private:	// User declarations
public:		// User declarations
        __fastcall THardware(TComponent* Owner);
        void LoadSettings(TIniFile *ini);
        void SaveSettings(TIniFile *ini);
};
//---------------------------------------------------------------------------
extern PACKAGE THardware *Hardware;
//---------------------------------------------------------------------------
#endif
