//---------------------------------------------------------------------------

#include <vcl.h>
#include <math.h>
#pragma hdrstop

#include "main_.h"
#include "Speed_.h"
#include "zx81config.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TSpeed *Speed;
//---------------------------------------------------------------------------
__fastcall TSpeed::TSpeed(TComponent* Owner)
        : TForm(Owner)
{
        AccurateTStates=65000;

        TIniFile *ini;

        ini = new TIniFile(ChangeFileExt(Application->ExeName, ".INI" ));
        LoadSettings(ini);
        delete ini;
}
//---------------------------------------------------------------------------
void __fastcall TSpeed::Button1Click(TObject *Sender)
{
        Form1->Speed1->Checked=false;
        Close();
}
//---------------------------------------------------------------------------


void __fastcall TSpeed::Recalc(TObject *Sender)
{
        double pwr,scale;

        AccurateTStates=63980;

        if (zx81.NTSC) AccurateTStates=54166;

        pwr  = AccurateSpeed->Position - 50;
        pwr *= (3.0/50.0);
        scale = pow(2,pwr);
        AccurateTStates *= scale;
}
//---------------------------------------------------------------------------
void TSpeed::LoadSettings(TIniFile *ini)
{
        Top = ini->ReadInteger("SPEED","Top",Top);
        Left = ini->ReadInteger("SPEED","Left",Left);
        //Height = ini->ReadInteger("SPEED","Height",Height);
        //Width = ini->ReadInteger("SPEED","Width",Width);

        //DirtyFastTStates = ini->ReadInteger("SPEED","DFAST",DirtyFastTStates);
        //DirtySlowTStates = ini->ReadInteger("SPEED","DSLOW",DirtySlowTStates);
        AccurateTStates = ini->ReadInteger("SPEED","DACC",AccurateTStates);

        AccurateSpeed->Position = ini->ReadInteger("SPEED","SACC",AccurateSpeed->Position);
        //FastMode->Position = ini->ReadInteger("SPEED","SFAST",FastMode->Position);
        //SlowMode->Position = ini->ReadInteger("SPEED","SSLOW",SlowMode->Position);
        EnableFrameSkip->Checked = ini->ReadInteger("SPEED","FRAMESKIP", false);

        EnableFrameSkipClick(NULL);
        //ChangeMode();

        if (Form1->Speed1->Checked) Show();
}

void TSpeed::SaveSettings(TIniFile *ini)
{
        ini->WriteInteger("SPEED","Top",Top);
        ini->WriteInteger("SPEED","Left",Left);
        //ini->WriteInteger("SPEED","Height",Height);
        //ini->WriteInteger("SPEED","Width",Width);

        //ini->WriteInteger("SPEED","DFAST",DirtyFastTStates);
        //ini->WriteInteger("SPEED","DSLOW",DirtySlowTStates);
        ini->WriteInteger("SPEED","DACC",AccurateTStates);

        ini->WriteInteger("SPEED","SACC",AccurateSpeed->Position);
        //ini->WriteInteger("SPEED","SFAST",FastMode->Position);
        //ini->WriteInteger("SPEED","SSLOW",SlowMode->Position);
        ini->WriteInteger("SPEED","FRAMESKIP",EnableFrameSkip->Checked);
}
void __fastcall TSpeed::FormClose(TObject *Sender, TCloseAction &Action)
{
        Form1->Speed1->Checked=false;
}
//---------------------------------------------------------------------------

void __fastcall TSpeed::EnableFrameSkipClick(TObject *Sender)
{
        if (EnableFrameSkip->Checked) zx81.frameskip=0;
        else zx81.frameskip=-1;
}
//---------------------------------------------------------------------------

