//---------------------------------------------------------------------------

#ifndef TapeMan_H
#define TapeMan_H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Grids.hpp>
#include <ComCtrls.hpp>
#include <Dialogs.hpp>
#include <IniFiles.hpp>

#include <stdio.h>
#include <Menus.hpp>
//---------------------------------------------------------------------------
#define BYTE unsigned char
#define MAXFILES 99
#define HEADER_ID "EO81"

class TTape : public TForm
{
__published:	// IDE-managed Components
        THeaderControl *HeaderControl1;
        TStringGrid *StringGrid;
        TOpenDialog *LoadTapeDialog;
        TSaveDialog *SaveTapeDialog;
        TOpenDialog *InsertBlockDialog;
        TSaveDialog *ExtractBlockDialog;
        TMainMenu *MainMenu1;
        TMenuItem *Tape1;
        TMenuItem *Block1;
        TMenuItem *NewTape1;
        TMenuItem *OpenTape1;
        TMenuItem *SaveTape1;
        TMenuItem *Convert1;
        TMenuItem *InsertBlock1;
        TMenuItem *ExtractBlock1;
        TMenuItem *TapetoWave1;
        TMenuItem *BlocktoWave1;
        TMenuItem *N1;
        TMenuItem *MoveBlockUp1;
        TMenuItem *MoveBlockDown1;
        TMenuItem *N2;
        TMenuItem *DeleteBlock1;
        TMenuItem *N3;
        TMenuItem *AutoRewind;
        TMenuItem *AutoLoad;
        void __fastcall StringGridDblClick(TObject *Sender);
        void __fastcall FormResize(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall NewTape1Click(TObject *Sender);
        void __fastcall OpenTape1Click(TObject *Sender);
        void __fastcall SaveTape1Click(TObject *Sender);
        void __fastcall TapetoWave1Click(TObject *Sender);
        void __fastcall BlocktoWave1Click(TObject *Sender);
        void __fastcall InsertBlock1Click(TObject *Sender);
        void __fastcall ExtractBlock1Click(TObject *Sender);
        void __fastcall MoveBlockUp1Click(TObject *Sender);
        void __fastcall MoveBlockDown1Click(TObject *Sender);
        void __fastcall DeleteBlock1Click(TObject *Sender);
        void __fastcall AutoRewindClick(TObject *Sender);
        void __fastcall AutoLoadClick(TObject *Sender);
private:	// User declarations
        void __fastcall WMGetMinMaxInfo(TWMGetMinMaxInfo &Message);
        int LoadBlock(AnsiString FileName);
        int SaveBlock(AnsiString filename,FILE * fp, int Block);
        BYTE *NewFile;
        long NewFileLen;
        void RecalcCurPos();
        AnsiString FileName, BlockName;
        int CurrentPosition;
        BYTE *File[MAXFILES];
        bool Changed;

        BEGIN_MESSAGE_MAP
          MESSAGE_HANDLER(WM_GETMINMAXINFO, TWMGetMinMaxInfo, WMGetMinMaxInfo)
        END_MESSAGE_MAP(TForm)


public:		// User declarations
        int SaveTapeFile(AnsiString FileName);
        int LoadTapeFile(AnsiString FileName);
        void Rewind(void);
        void NextFile(void);
        BYTE *GetCurrentFile(void);
        int GetCurrentFileLen(void);
        bool FindFile(BYTE *zx81Name);
        void CloseTape(void);
        void NewTape(void);
        void AddBlock(BYTE *zx81Name, BYTE *ptr, int len);
        bool IsTape(AnsiString FileName);
        __fastcall TTape(TComponent* Owner);
        void LoadSettings(TIniFile *ini);
        void SaveSettings(TIniFile *ini);
};
//---------------------------------------------------------------------------
extern PACKAGE TTape *Tape;
//---------------------------------------------------------------------------
#endif
