//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "kb_.h"
#include "kbstatus.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TKb *Kb;
//---------------------------------------------------------------------------
__fastcall TKb::TKb(TComponent* Owner)
        : TForm(Owner)
{
        if (CursorMode->ItemIndex==-1) CursorMode->ItemIndex=1;

        TIniFile *ini;

        ini = new TIniFile(ChangeFileExt(Application->ExeName, ".INI" ));
        LoadSettings(ini);
        delete ini;
}
//---------------------------------------------------------------------------
void __fastcall TKb::Button1Click(TObject *Sender)
{
        switch(CursorMode->ItemIndex)
        {
        case 0:
                PCKeySetCursor('5', '6', '7', '8', 0);
                break;
        case 1:
                PCKeySetCursor('5', '6', '7', '8', 1);
                break;
        case 2:
                PCKeySetCursor('B', 'V', 'C', 'N', 0);
                break;
        case 3:
                PCKeySetCursor('B', 'V', 'C', 'N', 1);
                break;
        case 4:
                PCKeySetCursor(toupper(CustomLeft->Text[1]),
                                toupper(CustomDown->Text[1]),
                                toupper(CustomUp->Text[1]),
                                toupper(CustomRight->Text[1]),
                                0);
        }

        if (RadioButton1->Checked) PCKeySetCTRL(0);
        if (RadioButton2->Checked) PCKeySetCTRL('0');
        //if (RadioButton3->Checked) PCKeySetCTRL('.');

        if (Sender) Close();
}
//---------------------------------------------------------------------------
void __fastcall TKb::CursorModeChange(TObject *Sender)
{
        if (CursorMode->ItemIndex==4)
        {
                CustomLeft->Enabled=true;
                CustomRight->Enabled=true;
                CustomUp->Enabled=true;
                CustomDown->Enabled=true;
        }
        else
        {
                CustomLeft->Enabled=false;
                CustomRight->Enabled=false;
                CustomUp->Enabled=false;
                CustomDown->Enabled=false;
        }

}
//---------------------------------------------------------------------------
void TKb::LoadSettings(TIniFile *ini)
{
        Top = ini->ReadInteger("KB","Top",Top);
        Left = ini->ReadInteger("KB","Left",Left);

        //ini->ReadInteger("KB","Height",Height);
        //ini->ReadInteger("KB","Width",Width);

        CursorMode->ItemIndex = ini->ReadInteger("KB","CursorMode", CursorMode->ItemIndex);
        CustomLeft->Text = ini->ReadString("KB","CustomLeft", CustomLeft->Text);
        CustomDown->Text = ini->ReadString("KB","CustomDown", CustomDown->Text);
        CustomUp->Text = ini->ReadString("KB","CustomUp", CustomUp->Text);
        CustomRight->Text = ini->ReadString("KB","CustomRight", CustomRight->Text);

        RadioButton1->Checked = ini->ReadBool("KB","CTRLFunc", RadioButton1->Checked);
        RadioButton2->Checked = ini->ReadBool("KB","CTRL0", RadioButton2->Checked);
        //RadioButton3->Checked = ini->ReadBool("KB","SYMSHIFT", RadioButton3->Checked);

        CursorModeChange(NULL);
        Button1Click(NULL);
}

void TKb::SaveSettings(TIniFile *ini)
{
        ini->WriteInteger("KB","Top",Top);
        ini->WriteInteger("KB","Left",Left);
        //ini->WriteInteger("KB","Height",Height);
        //ini->WriteInteger("KB","Width",Width);

        ini->WriteInteger("KB","CursorMode", CursorMode->ItemIndex);
        ini->WriteString("KB","CustomLeft", CustomLeft->Text);
        ini->WriteString("KB","CustomDown", CustomDown->Text);
        ini->WriteString("KB","CustomUp", CustomUp->Text);
        ini->WriteString("KB","CustomRight", CustomRight->Text);

        ini->WriteBool("KB","CTRLFunc", RadioButton1->Checked);
        ini->WriteBool("KB","CTRL0", RadioButton2->Checked);
        //ini->WriteBool("KB","SYMSHIFT", RadioButton3->Checked);
}



