//---------------------------------------------------------------------------

#ifndef TZXManH
#define TZXManH

#ifdef __cplusplus
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Grids.hpp>
#include <Menus.hpp>
#include <Dialogs.hpp>
#include <ExtCtrls.hpp>
#include <IniFiles.hpp>
//---------------------------------------------------------------------------
class TTZX : public TForm
{
__published:	// IDE-managed Components
        TStringGrid *Table;
        TMainMenu *MainMenu1;
        TMenuItem *File1;
        TMenuItem *Open1;
        TMenuItem *Save1;
        TMenuItem *SaveAs1;
        TOpenDialog *OpenDialog;
        TButton *PlayBtn;
        TButton *StopBtn;
        TMenuItem *NewTZX;
        TSaveDialog *SaveDialog;
        TMenuItem *Options1;
        TMenuItem *ConvertBlocktoWav1;
        TMenuItem *ConvertTapetoWav1;
        TMenuItem *FlashLoad1;
        TPopupMenu *PopupMenu1;
        TMenuItem *InsertBlock1;
        TMenuItem *DeleteBlock1;
        TMenuItem *ExtractBlock1;
        TMenuItem *N2;
        TMenuItem *N3;
        TMenuItem *MoveBlockUp1;
        TMenuItem *MoveBlockDown1;
        TMenuItem *EditBlock1;
        TMenuItem *N4;
        TMenuItem *ArchiveInfo1;
        TMenuItem *TextDescription1;
        TMenuItem *Pause1;
        TMenuItem *HardwareInformation1;
        TMenuItem *Information1;
        TMenuItem *Loop1;
        TMenuItem *LoopStart1;
        TMenuItem *LoopEnd1;
        TMenuItem *Group1;
        TMenuItem *GroupStart1;
        TMenuItem *GroupEnd1;
        TMenuItem *Message1;
        TMenuItem *Data1;
        TMenuItem *AutoStartStop;
        TMenuItem *Block1;
        TMenuItem *N5;
        TMenuItem *EditBlock2;
        TMenuItem *N6;
        TMenuItem *InsertBlock2;
        TMenuItem *ExtractBlock2;
        TMenuItem *N7;
        TMenuItem *MoveBlockUp2;
        TMenuItem *MoveBlockDown2;
        TMenuItem *N8;
        TMenuItem *DeleteBlock2;
        TMenuItem *Information2;
        TMenuItem *Group2;
        TMenuItem *Loop2;
        TMenuItem *Data2;
        TMenuItem *Pause2;
        TMenuItem *ArchiveInformation1;
        TMenuItem *HardwareInformation2;
        TMenuItem *Message2;
        TMenuItem *Text1;
        TMenuItem *N1;
        TMenuItem *N9;
        TOpenDialog *InsertBlockDialog1;
        TSaveDialog *ExtractDialog1;
        void __fastcall Open1Click(TObject *Sender);
        void __fastcall PlayBtnClick(TObject *Sender);
        void __fastcall StopBtnClick(TObject *Sender);
        void __fastcall FormResize(TObject *Sender);
        void __fastcall TableSelectCell(TObject *Sender, int ACol,
          int ARow, bool &CanSelect);
        void __fastcall NewTZXClick(TObject *Sender);
        void __fastcall SaveAs1Click(TObject *Sender);
        void __fastcall FlashLoad1Click(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall TableContextPopup(TObject *Sender,
          TPoint &MousePos, bool &Handled);
        void __fastcall MoveBlockUp1Click(TObject *Sender);
        void __fastcall MoveBlockDown1Click(TObject *Sender);
        void __fastcall DeleteBlock1Click(TObject *Sender);
        void __fastcall EditBlock1Click(TObject *Sender);
        void __fastcall AutoStartStopClick(TObject *Sender);
        void __fastcall HardwareInformation1Click(TObject *Sender);
        void __fastcall ArchiveInfo1Click(TObject *Sender);
        void __fastcall TextDescription1Click(TObject *Sender);
        void __fastcall Pause1Click(TObject *Sender);
        void __fastcall Data1Click(TObject *Sender);
        void __fastcall ExtractBlock1Click(TObject *Sender);
        void __fastcall Save1Click(TObject *Sender);
private:	// User declarations
        int Mx, My;
public:		// User declarations
        __fastcall TTZX(TComponent* Owner);
        void LoadSettings(TIniFile *ini);
        void SaveSettings(TIniFile *ini);
        void AddBlock(char *Buffer, int Len);
        void MergeBlocks(void);
        void UpdateTable(void);
        void RecStopCheck(void);
        void RecordByte(unsigned char c);

        int Recording, RecState;
        unsigned char RecBuf[65536],*RecPtr;


};
//---------------------------------------------------------------------------
extern PACKAGE TTZX *TZX;
//---------------------------------------------------------------------------

extern "C" void TZXClockTick(int TStates);
extern "C" int TZXGetEarState(void);
extern "C" int TZXByte;
extern "C" void TZXStartPlaying(void);
extern "C" void TZXWriteByte(unsigned char Byte);


#else

extern void TZXClockTick(int TStates);
extern int TZXGetEarState(void);
extern int TZXByte;
extern void TZXStartPlaying(void);
extern void TZXWriteByte(unsigned char Byte);

#endif

#define TZX_BYTE_EMPTY -1

#endif
