//---------------------------------------------------------------------------

#include <vcl.h>
#include <stdio.h>
#pragma hdrstop

#include "tzxfile.h"
//---------------------------------------------------------------------------

#pragma package(smart_init)

#define TZX_BYTE_EMPTY -1
#define TPAUSE 6

int TZXByte=TZX_BYTE_EMPTY;

bool TTZXFile::EventGeneral(void)
{
        static unsigned char *data;
        static unsigned short *SyncPulses, *Alphabet, *PulseList;
        static int Flags, DataLen;
        static unsigned short PilotLen;
        static unsigned short NoPilotPulses;
        static unsigned short NoSyncPulses;
        static unsigned short MaxPulsesBit;
        static unsigned short NoSymbols;
        static unsigned short FinalBits;
        static unsigned char CurrentByte, CurrentBitCount, PulseCount=0;
        static int CurrentBit;

        if (Pause)
        {
                EarState=0;
                TZXEventCounter=3250 * ((Pause<6) ? TPAUSE : Pause);
                Pause=0;
                return(false);
        }

        if (!BlockInProgress)
        {
                data=Tape[CurBlock].Data.Data;
                SyncPulses=Tape[CurBlock].SyncPulses;
                Alphabet=Tape[CurBlock].Alphabet;
                Flags=Tape[CurBlock].Head.General.Flags;
                DataLen=Tape[CurBlock].Head.General.DataLen;
                PilotLen=Tape[CurBlock].Head.General.PilotLen;
                NoPilotPulses=Tape[CurBlock].Head.General.PilotPulses;
                NoSyncPulses=Tape[CurBlock].Head.General.SyncPulses;
                MaxPulsesBit=Tape[CurBlock].Head.General.MaxPulsesBit;
                NoSymbols=Tape[CurBlock].Head.General.NoSymbols;
                FinalBits=Tape[CurBlock].Head.General.FinalBits;

                CurrentBitCount=0;
                EarState= !(Flags&1);

                CurrentByte=*(data++);
                CurrentBitCount=8;
                CurrentBit=(CurrentByte&128)==128;
                PulseList = Alphabet + (CurrentBit*MaxPulsesBit);
                BlockInProgress=true;
                PulseCount=0;
                TZXByte=CurrentByte;
        }

        if (FlashLoad)
        {
                if (TZXByte==TZX_BYTE_EMPTY)
                {
                        CurrentByte=*(data++);
                        CurrentBitCount=8;
                        CurrentBit=(CurrentByte&128)==128;
                        PulseList = Alphabet + (CurrentBit*MaxPulsesBit);
                        BlockInProgress=true;
                        PulseCount=0;
                        TZXByte=CurrentByte;

                        if (!--DataLen)
                        {
                                EarState=0;
                                TZXByte=TZX_BYTE_EMPTY;
                                Pause= Tape[CurBlock].Pause;
                                EventNextBlock();
                                return(true);
                        }
                        return(false);
                }
                TZXEventCounter=1;
                return(false);
        }
        else
        {
                if (*PulseList && PulseCount<MaxPulsesBit)
                {
                        TZXEventCounter += *PulseList;
                        EarState=!EarState;
                        PulseList++;
                        PulseCount++;
                }
                else
                {
                        CurrentBitCount--;
                        PulseCount=0;

                        if (!CurrentBitCount)
                        {
                                CurrentByte=*(data++);
                                CurrentBitCount=8;
                                if (!--DataLen)
                                {
                                        EarState=0;
                                        TZXByte=TZX_BYTE_EMPTY;
                                        Pause=Tape[CurBlock].Pause;
                                        EventNextBlock();
                                        return(true);
                                }
                        }
                        else    CurrentByte<<=1;

                        CurrentBit=(CurrentByte&128)==128;
                        PulseList = Alphabet + (CurrentBit*MaxPulsesBit);
                }
                return(false);
        }
}

