//---------------------------------------------------------------------------

#include <vcl.h>
#include <stdio.h>
#pragma hdrstop

#include "tzxfile.h"
//---------------------------------------------------------------------------

#pragma package(smart_init)

int TTZXFile::AddTextBlock(char *str)
{
        unsigned char *data;

        data=(unsigned char *)malloc(strlen(str)+1);
        strcpy(data, str);

        Tape[Blocks].BlockID=TZX_BLOCK_TEXT;
        Tape[Blocks].Data.Data=data;
        Tape[Blocks].Head.Text.TextLen=strlen(str);
        return(Blocks++);
}

int TTZXFile::AddHWTypeBlock(unsigned char type, unsigned char id)
{
        struct TZXHWInfo *data;

        data=(struct TZXHWInfo *) malloc(sizeof(struct TZXHWInfo));

        data->Type = type;
        data->ID = id;
        data->Information = 0;

        Tape[Blocks].BlockID=TZX_BLOCK_HWTYPE;
        Tape[Blocks].Data.HWTypes=data;
        Tape[Blocks].Head.HWType.NoTypes=1;
        return(Blocks++);
}

int TTZXFile::AddPauseBlock(int len)
{
        if (len>65535)
        {
                AddPauseBlock(65535);
                return(AddPauseBlock(len-65535));
        }

        Tape[Blocks].BlockID=TZX_BLOCK_PAUSE;
        Tape[Blocks].Pause=len;
        return(Blocks++);
}

int TTZXFile::AddGeneralBlock(char *data, int len)
{
        char *DataBuf;
        int i;

        unsigned short *at,atdata[]=
        {
                0x0212, 0x0208, 0x0212, 0x0208, 0x0212, 0x0208, 0x0212, 0x1251,
                0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
                0x0212, 0x0208, 0x0212, 0x0208, 0x0212, 0x0208, 0x0212, 0x0208,
                0x0212, 0x0208, 0x0212, 0x0208, 0x0212, 0x0208, 0x0212, 0x1251
        };

        at=(unsigned short *) malloc(32 * sizeof(unsigned short));
        for(i=0;i<32;i++) at[i]=atdata[i];

        DataBuf=(char *)malloc(len);
        memcpy(DataBuf, data, len);

        Tape[Blocks].BlockID=TZX_BLOCK_GENERAL;

        Tape[Blocks].Pause=0;
        Tape[Blocks].Head.General.Flags=1;
        Tape[Blocks].Head.General.PilotLen=0;
        Tape[Blocks].Head.General.PilotPulses=0;
        Tape[Blocks].Head.General.SyncPulses=0;
        Tape[Blocks].Head.General.MaxPulsesBit=16;
        Tape[Blocks].Head.General.NoSymbols=2;
        Tape[Blocks].Head.General.FinalBits=8;
        Tape[Blocks].Head.General.DataLen=len;
        Tape[Blocks].Data.Data=DataBuf;

        Tape[Blocks].SyncPulses=NULL;
        Tape[Blocks].Alphabet=at;

        return(Blocks++);
}

int TTZXFile::AddArchiveBlock(char *str)
{
        char *p;

        p=(unsigned char *)malloc(strlen(str)+2);
        memcpy(p+2, str, strlen(str));
        p[0]=0;
        p[1]=strlen(str);

        Tape[Blocks].BlockID=TZX_BLOCK_ARCHIVE;
        Tape[Blocks].Data.Data=p;
        Tape[Blocks].Head.Archive.NoStrings=1;
        return(Blocks++);

}





