//---------------------------------------------------------------------------

#include <vcl.h>
#include <stdio.h>
#pragma hdrstop

#include "tzxfile.h"
#include "zx81.h"
//---------------------------------------------------------------------------

#pragma package(smart_init)

extern "C" int kbBreak;

int TZXEventCounter=0;

void TTZXFile::Start(void)
{
        if (Playing) return;

        StartBlock=CurBlock;
        Playing=true;
        BlockInProgress=false;
        TZXEventCounter=6*3250;
        EarState=0;
        Pause=0;
}

void TTZXFile::Stop(bool Error)
{
        Playing=false;
        BlockInProgress=false;
        EarState=0;
        Pause=0;
        //if (Error) kbBreak=256;
}

bool TTZXFile::ClockTick(int Tstates)
{
        bool NewBlock=false;
        if (!Playing) return(false);

        TZXEventCounter-=Tstates;
        while(Playing && (TZXEventCounter<0))
                if (StateChange()) NewBlock=true;

        return(NewBlock);
}

bool TTZXFile::StateChange(void)
{
        bool flag;

        switch(Tape[CurBlock].BlockID)
        {
        case TZX_BLOCK_GENERAL:
                flag=EventGeneral();
                if (flag && AutoStart) Stop(false);
                return(flag);
        case TZX_BLOCK_PAUSE:
                return(EventPause());
        case TZX_BLOCK_JUMP:
                return(EventJump());
        case TZX_BLOCK_LSTART:
                return(EventLStart());
        case TZX_BLOCK_LEND:
                return(EventLEnd());
        case TZX_BLOCK_SETLEVEL:
                return(EventSetLevel());
        default:
                EventNextBlock();
                return(true);
        }
}

void TTZXFile::EventNextBlock(void)
{
        BlockInProgress=false;
        CurBlock++;
        if (CurBlock==Blocks) CurBlock=0; //Stop();
        if (CurBlock==StartBlock) Stop(true);
}

bool TTZXFile::EventPause(void)
{
        static int PauseCounter;

        EarState=0;
        if (!Tape[CurBlock].Pause) Stop(false);

        if (!FlashLoad)
        {
                if (!BlockInProgress)
                {
                        PauseCounter=Tape[CurBlock].Pause;
                        BlockInProgress=true;
                }

                TZXEventCounter += 3250;
                if (--PauseCounter>0) return (false);
        }

        BlockInProgress=false;
        TZXEventCounter=-1;
        EventNextBlock();
        return(true);
}

bool TTZXFile::EventJump(void)
{
        CurBlock = (CurBlock + (short)Tape[CurBlock].Head.Jump.JumpRel) -1;
        EventNextBlock();
        return(true);
}

bool TTZXFile::EventLStart(void)
{
        LoopBlockStart=CurBlock;
        LoopBlockCounter=Tape[CurBlock].Head.LStart.Repeats;

        EventNextBlock();
        return(true);
}

bool TTZXFile::EventLEnd(void)
{
        if (--LoopBlockCounter>1) CurBlock=LoopBlockStart;
        EventNextBlock();
        return(true);
}


bool TTZXFile::EventSetLevel(void)
{
        EarState=Tape[CurBlock].Head.SetLevel.Level;
        EventNextBlock();
        return(true);
}


