//---------------------------------------------------------------------------

#include <vcl.h>
#include <stdio.h>
#pragma hdrstop

#include "tzxfile.h"
//---------------------------------------------------------------------------

#pragma package(smart_init)
extern char TZX_ID[];

void TTZXFile::WriteByte(FILE *f, unsigned char a)
{
        fwrite(&a, 1,1, f);
}

void TTZXFile::WriteWord(FILE *f, int c)
{
        unsigned short a,b;
        a=c&255; c>>=8;
        b=c&255;

        WriteByte(f, a);
        WriteByte(f, b);
}

void TTZXFile::WriteDWord(FILE *f, int c)
{
        unsigned int a,b;
        a=c&65535; c>>=16;
        b=c&65535;

        WriteWord(f, a);
        WriteWord(f, b);
}

void TTZXFile::Write3Bytes(FILE *f, int d)
{
        unsigned int a,b,c;
        a=d&255; d>>=8;
        b=d&255; d>>=8;
        c=d&255;

        WriteByte(f,a);
        WriteByte(f,b);
        WriteByte(f,c);
}

void TTZXFile::WriteBytes(FILE *f, int len, void *buf)
{
        fwrite(buf, 1, len, f);
}

void TTZXFile::SaveROMBlock(int Block, FILE *f)
{
}

void TTZXFile::SaveTurboBlock(int Block, FILE *f)
{
}
void TTZXFile::SaveToneBlock(int Block, FILE *f)
{
}

void TTZXFile::SavePulseBlock(int Block, FILE *f)
{
}

void TTZXFile::SaveDataBlock(int Block, FILE *f)
{
}

void TTZXFile::SaveDRecBlock(int Block, FILE *f)
{
}

void TTZXFile::SaveCSWBlock(int Block, FILE *f)
{
}

void TTZXFile::SaveGeneralBlock(int Block, FILE *f)
{
        int i;

        i  = 11;
        i += Tape[Block].Head.General.DataLen;
        i += Tape[Block].Head.General.SyncPulses*2;
        i += Tape[Block].Head.General.MaxPulsesBit
                        * Tape[Block].Head.General.NoSymbols
                        * 2;

        WriteByte(f,Tape[Block].BlockID);
        WriteDWord(f, i);
        WriteByte(f, Tape[Block].Head.General.Flags);
        WriteWord(f, Tape[Block].Head.General.PilotLen);
        WriteWord(f, Tape[Block].Head.General.PilotPulses);
        WriteByte(f, Tape[Block].Head.General.SyncPulses);

        for(i=0;i<Tape[Block].Head.General.SyncPulses;i++)
                WriteWord(f, Tape[Block].SyncPulses[i]);

        WriteByte(f, Tape[Block].Head.General.MaxPulsesBit);
        WriteByte(f, Tape[Block].Head.General.NoSymbols);

        for(i=0; i< Tape[Block].Head.General.MaxPulsesBit
                        * Tape[Block].Head.General.NoSymbols;
                                i++)
                WriteWord(f, Tape[Block].Alphabet[i]);

        WriteByte(f, Tape[Block].Head.General.FinalBits);
        WriteWord(f, Tape[Block].Pause);
        WriteBytes(f, Tape[Block].Head.General.DataLen,
                        Tape[Block].Data.Data);
}

void TTZXFile::SavePauseBlock(int Block, FILE *f)
{
        WriteByte(f,Tape[Block].BlockID);
        WriteWord(f,Tape[Block].Pause);
}

void TTZXFile::SaveGStartBlock(int Block, FILE *f)
{
        WriteByte(f,Tape[Block].BlockID);
        WriteByte(f,Tape[Block].Head.GStart.NameLen);
        WriteBytes(f, Tape[CurBlock].Head.GStart.NameLen
                        ,Tape[CurBlock].Data.Data);
}

void TTZXFile::SaveGEndBlock(int Block, FILE *f)
{
        WriteByte(f, Tape[Block].BlockID);
}

void TTZXFile::SaveJumpBlock(int Block, FILE *f)
{
        WriteByte(f, Tape[Block].BlockID);
        WriteByte(f, Tape[Block].Head.Jump.JumpRel);
}

void TTZXFile::SaveLStartBlock(int Block, FILE *f)
{
        WriteByte(f, Tape[Block].BlockID);
        WriteWord(f, Tape[Block].Head.LStart.Repeats);
}

void TTZXFile::SaveLEndBlock(int Block, FILE *f)
{
        WriteByte(f, Tape[Block].BlockID);
}

void TTZXFile::SaveSBlock(int Block, FILE *f)
{
}
void TTZXFile::SaveStop48KBlock(int Block, FILE *f)
{
}

void TTZXFile::SaveSetLevelBlock(int Block, FILE *f)
{
        WriteByte(f, Tape[Block].BlockID);
        WriteDWord(f,1);
        WriteByte(f, Tape[Block].Head.SetLevel.Level);
}

void TTZXFile::SaveTextBlock(int Block, FILE *f)
{
        WriteByte(f, Tape[Block].BlockID);
        WriteByte(f, Tape[Block].Head.Text.TextLen);
        WriteBytes(f, Tape[Block].Head.Text.TextLen,
                        Tape[Block].Data.Data);
}

void TTZXFile::SaveMessageBlock(int Block, FILE *f)
{
        WriteByte(f, Tape[Block].BlockID);
        WriteByte(f, Tape[Block].Head.Message.Time);
        WriteByte(f, Tape[Block].Head.Message.TextLen);
        WriteBytes(f, Tape[Block].Head.Message.TextLen,
                        Tape[Block].Data.Data);
}

void TTZXFile::SaveArchiveBlock(int Block, FILE *f)
{
        WriteByte(f, Tape[Block].BlockID);
        WriteWord(f, Tape[Block].Head.Archive.BlockLen + 1);
        WriteByte(f, Tape[Block].Head.Archive.NoStrings);
        WriteBytes(f, Tape[Block].Head.Archive.BlockLen
                        , Tape[Block].Data.Data);
}

void TTZXFile::SaveHWTypeBlock(int Block, FILE *f)
{
        int i;

        WriteByte(f, Tape[Block].BlockID);
        WriteByte(f, Tape[Block].Head.HWType.NoTypes);

        for(i=0;i<Tape[Block].Head.HWType.NoTypes;i++)
        {
                WriteByte(f,Tape[Block].Data.HWTypes[i].Type);
                WriteByte(f,Tape[Block].Data.HWTypes[i].ID);
                WriteByte(f,Tape[Block].Data.HWTypes[i].Information);
        }
}

void TTZXFile::SaveCustomBlock(int Block, FILE *f)
{
}
void TTZXFile::SaveGlueBlock(int Block, FILE *f)
{
}

void TTZXFile::SaveUnknownBlock(int Block, FILE *f)
{
        int length;
        unsigned char *data;

        WriteByte(f, Tape[Block].Head.Unknown.type);
        WriteDWord(f,Tape[Block].Head.Unknown.length);
        WriteBytes(f,Tape[Block].Head.Unknown.length,
                        Tape[Block].Data.Data);
}

bool TTZXFile::SaveFile(AnsiString FileName)
{
        FILE *f;
        int i;

        struct TZXHeader head;

        f=fopen(FileName.c_str(), "wb");
        if (!f) return(false);
        this->FileName=FileName;

        fwrite(TZX_ID, 8,1, f);
        fputc(0x01,f);
        fputc(0x20,f);

        for(i=0;i<Blocks;i++)
        {
                //fputc(Tape[i].BlockID,f);

                switch(Tape[i].BlockID)
                {
                case TZX_BLOCK_ROM:      SaveROMBlock(i,f); break;
                case TZX_BLOCK_TURBO:    SaveTurboBlock(i,f); break;
                case TZX_BLOCK_TONE:     SaveToneBlock(i,f); break;
                case TZX_BLOCK_PULSE:    SavePulseBlock(i,f); break;
                case TZX_BLOCK_DATA:     SaveDataBlock(i,f); break;
                case TZX_BLOCK_DREC:     SaveDRecBlock(i,f); break;
                case TZX_BLOCK_CSW:      SaveCSWBlock(i,f); break;
                case TZX_BLOCK_GENERAL:  SaveGeneralBlock(i,f); break;
                case TZX_BLOCK_PAUSE:    SavePauseBlock(i,f); break;
                case TZX_BLOCK_GSTART:   SaveGStartBlock(i,f); break;
                case TZX_BLOCK_GEND:     SaveGEndBlock(i,f); break;
                case TZX_BLOCK_JUMP:     SaveJumpBlock(i,f); break;
                case TZX_BLOCK_LSTART:   SaveLStartBlock(i,f); break;
                case TZX_BLOCK_LEND:     SaveLEndBlock(i,f); break;
                case TZX_BLOCK_SBLOCK:   SaveSBlock(i,f); break;
                case TZX_BLOCK_STOP48K:  SaveStop48KBlock(i,f); break;
                case TZX_BLOCK_SETLEVEL: SaveSetLevelBlock(i,f); break;
                case TZX_BLOCK_TEXT:     SaveTextBlock(i,f); break;
                case TZX_BLOCK_MESSAGE:  SaveMessageBlock(i,f); break;
                case TZX_BLOCK_ARCHIVE:  SaveArchiveBlock(i,f); break;
                case TZX_BLOCK_HWTYPE:   SaveHWTypeBlock(i,f); break;
                case TZX_BLOCK_CUSTOM:   SaveCustomBlock(i,f); break;
                case TZX_BLOCK_GLUE:     SaveGlueBlock(i,f); break;
                case 0:
                default:                 SaveUnknownBlock(i,f); break;
                }
        }

        fclose(f);
        return(true);
}
