//---------------------------------------------------------------------------

#ifndef WavFileH
#define WavFileH

struct RIFFHeader
{
        char Head[4];
        unsigned int TotalLen;
        char Type[4];
};

struct RIFFFormat
{
        char Head[4];
        unsigned int BlkLen;
        short fill;
        short NoChannels;
        unsigned int SampleRate;
        unsigned int BytesSec;
        short BytesSample;
        short BitsSample;
};

struct RIFFData
{
        char Head[4];
        unsigned int DataLen;
        unsigned char *Data;
};

struct CSW
{
        char Sig[22];
        char Terminator;
        char MajVer;
        char MinVer;
        char SampleRateLo, SampleRateHi;
        char Compression;
        char Flags;
        char Reserved[4];
};

class TWavFile
{
private:
        AnsiString FileName;
        struct RIFFHeader Head;
        struct RIFFFormat Format;
        struct RIFFData Data;
        bool Signed;
        unsigned int MemAllocated;
public:
        unsigned int SampleRate, NoSamples;
        bool Stereo;

        bool LoadFile(AnsiString Filename);
        bool SaveFile(AnsiString Filename);
        bool LoadCSW(AnsiString Filename);
        bool SaveCSW(AnsiString Filename);
        unsigned char Sample(unsigned int Pos, int Channel);
        bool NewFile(void);
        bool SetSample(unsigned int Pos, int Value);
        bool CanRecord(void);

        int Volume, Bias;

        TWavFile();
        ~TWavFile();
};
#endif
