//---------------------------------------------------------------------------

#ifndef wavload_H
#define wavload_H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Dialogs.hpp>
#include <ExtCtrls.hpp>
#include <IniFiles.hpp>

#include "WavFile.h"
#include <ComCtrls.hpp>
#include <Menus.hpp>
//---------------------------------------------------------------------------
class TWavLoad : public TForm
{
__published:	// IDE-managed Components
        TScrollBar *ScrollBar;
        TOpenDialog *LoadWavDialog;
        TImage *Image1;
        TButton *PlayBtn;
        TSaveDialog *SaveWavDialog;
        TButton *RecBtn;
        TTrackBar *Bias;
        TTrackBar *Volume;
        TMainMenu *MainMenu1;
        TMenuItem *Wa1;
        TMenuItem *NewWav1;
        TMenuItem *OpenWav1;
        TMenuItem *SaveWav1;
        TMenuItem *Options1;
        TMenuItem *ConvertNextBlock1;
        TMenuItem *N1;
        TMenuItem *AutoStartStop1;
        TMenuItem *UseLeftChannel1;
        TMenuItem *UseRightChannel1;
        TMenuItem *ConvertNextBlockTZX1;
        void __fastcall LoadClick(TObject *Sender);
        void __fastcall ScrollBarChange(TObject *Sender);
        void __fastcall PlayBtnClick(TObject *Sender);
        void __fastcall Image1MouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
        void __fastcall OKBtnClick(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall LeftBtnClick(TObject *Sender);
        void __fastcall RightBtnClick(TObject *Sender);
        void __fastcall SaveBtnClick(TObject *Sender);
        void __fastcall Send2TapeManClick(TObject *Sender);
        void __fastcall NewClick(TObject *Sender);
        void __fastcall RecBtnClick(TObject *Sender);
        void __fastcall VolumeChange(TObject *Sender);
        void __fastcall BiasChange(TObject *Sender);
        void __fastcall SaveWav1Click(TObject *Sender);
        void __fastcall OpenWav1Click(TObject *Sender);
        void __fastcall NewWav1Click(TObject *Sender);
        void __fastcall ConvertNextBlock1Click(TObject *Sender);
        void __fastcall UseLeftChannel1Click(TObject *Sender);
        void __fastcall UseRightChannel1Click(TObject *Sender);
        void __fastcall AutoStartStop1Click(TObject *Sender);
        void __fastcall ConvertNextBlockTZX1Click(TObject *Sender);
private:	// User declarations
        int TStatesSample;
        unsigned int TapePos;
        bool Playing, Recording, IgnoreZX81;
        int Threshold;
        int CurrentTStates, ScreenCounter;
        AnsiString StatusText;
        int Channel;
        AnsiString FileName;
        AnsiString RemoveExt(AnsiString Fname);
        int GetPulse(int *HighLen, int *LowLen, bool start);
        int GetBit(bool *bit, bool started);
        int GetByte(bool start);
        void EncodeBit(bool bit);
public:		// User declarations
        __fastcall TWavLoad(TComponent* Owner);
        void ClearImage();
        void UpdateImage();
        bool GetEarState();
        void ClockTick(int TStates, bool ZX81, bool MicState);
        void Stop(bool force);
        void Start();
        void StartRec();
        void DoCaption(AnsiString Message);
        bool IsWav(AnsiString FileName);
        void LoadFile(AnsiString FileName);
        void LoadSettings(TIniFile *ini);
        void SaveSettings(TIniFile *ini);
        void EncodeBlock(char *Data, int Len);
};
//---------------------------------------------------------------------------
extern PACKAGE TWavLoad *WavLoad;
//---------------------------------------------------------------------------
#endif
