
#ifndef ZX81CONFIG_H
#define ZX81CONFIG_H

#define MACHINEZX80 0
#define MACHINEZX81 1
#define MACHINEACE  2
#define MACHINETS1500 3
#define MACHINELAMBDA 4
#define MACHINEZX97LE 5

#define HIRESDISABLED 0
#define HIRESWRX 1
#define HIRESG007 2
#define HIRESMEMOTECH 3

#define CHRGENSINCLAIR 0
#define CHRGENDK 1
#define CHRGENQS 2
#define CHRGENCHR16 3

#define COLOURDISABLED 0
#define COLOURPRISM 1
#define COLOURLAMBDA 2
#define COLOURDDC 3
#define COLOURHAVEN 4
#define COLOURACE 5

#define CRCACE		0x0a09
#define CRCASZMIC	0xcac9
#define CRCH4TH		0xa5cd
#define CRCSG81		0x72f4
#define CRCSP81		0x877d
#define CRCTK85		0x28a9
#define CRCTREE4TH	0x9dc7
#define CRCTS1500	0x63b7
#define CRCZX80		0x3a68
#define CRCZX97LE	0x68bb
#define CRCZX81		0x2914
#define CRCLAMBDA	0x4d3c
#define CRC8300		0x0d4e
#define CRCR470         0x5413

typedef struct
{
        int dirtydisplay;
        int machine;
        int extfont;
        int shadowROM;
        int RAM816k;
        int protectROM;
        int RAMTOP;
        int ROMTOP;
        int truehires;
        int NTSC;
        char ROM80[256];
        char ROM81[256];
        char ROMACE[256];
        char ROMTS1000[256];
        char ROMTS1500[256];
        char ROMLAMBDA[256];
        char ROMPC8300[256];
        char ROMTK85[256];
        char ROM97LE[256];
        char ROMR470[256];
        int romtype;
        char cwd[256];
        int single_step;
        int inverse;
        int frameskip;
        int aysound;
        int aytype;
        int vsyncsound;
        int beepersound;
        int ts2050;
        int interceptload;
        int interceptsave;
        int TZXin, TZXout;
        int audioout,audioin;
        int colour;
        int m1not;
        int debug1, debug2;
        int romcrc;
        int autoload;
        int wobble;
        int chrgen, enableqschrgen;
} ZX81;

typedef struct
{
        int bankswitch;
        int protect08;
        int protectab;
        int protectb0;
        int protectb115;
        int saveram;
        unsigned char bankmem[16*16384];
} ZX97;

#ifdef __cplusplus

extern "C" ZX81 zx81;
extern "C" ZX97 zx97;
extern "C" void load_config();

#else

extern ZX81 zx81;
extern ZX97 zx97;
extern void load_config();

#endif
#endif

